# Node.js Leak Simulator

The Node.js leak simulator is a simple server script that creates heavy CPU load and a severe memory leak to demonstrate AppDynamics Node.js agent's value in diagnosing memory leaks and excessive resource consumption.

## Usage:

1. Download this package from https://registry.npmjs.org/leak-simulator/-/leak-simulator-1.0.1.tgz to a machine/VM with at least 6 cores and 16 GB of memory.
2. Unzip, open the ``index.js`` file and fill in your AppDynamics configuration details.
3. `` npm install ``
4. `` npm start ``
5. Go to your controller.
6. When the agent reports, open your controller and navigate to the newly discovered NodeJSLeaker application.
7. Navigate to  ``Tiers & Nodes | faucet<-xxx> | Memory``  and turn on the switch for Object Instance Tracking.
8. Wait 5-10 minutes.
9. Navigate to  ``Metric Browser | Application Infrastructure Performance | SuperLeak | Node.js``  to examine CPU, Memory, Garbage Collection and other Node.js server data.
10. Navigate back to  ``Tiers & Nodes | faucet<-xxx> | Memory``  to see a time graph of each tracked object, as well as to view tracked objects sorted by instance count, shallow size, and other metrics.
10. Navigate to  ``Metric Browser | Application Infrastructure Performance | SuperLeak | faucet<-xxx> | Object Instance Tracking``  to see all tracked objects and use metrics for specific object(s) to create custom dashboards and health rules/policies under the  ``Alert & Respond``  menu.